#ifndef dllclass_h_included
#define dllclass_h_included

#if __GNUC__ && ! defined (__declspec)
# error This example needs newer egcs 1.1 or newer. Sorry.
#endif

#if defined(_WIN32) || defined(__CYGWIN__)
#  ifdef DLL_EXPORT
#    define CXXDLL_SCOPE           __declspec(dllexport)
#  else
#    ifdef LIBCXXDLL_DLL_IMPORT
#      define CXXDLL_SCOPE         __declspec(dllimport)
#    endif
#  endif
#endif
#ifndef CXXDLL_SCOPE
#  define CXXDLL_SCOPE
#endif

CXXDLL_SCOPE struct
DllClassBase {
  virtual int virtual_method () const;
};

CXXDLL_SCOPE class 
DllClass : public DllClassBase {
public:
  DllClass (int i = 0);
  ~DllClass ();
  int non_virtual_method () const;
  virtual int virtual_method () const;
  CXXDLL_SCOPE static int instances;
private:
  int i_;
};

#endif /* dllclass_h_included */
